; Fargo IDE header
;=============================================================================
; Last save: Sat Jan 23 15:39:15  1999
; 9.15 106.0 106.0 106.0 106.0 106.0
;=============================================================================
;----------------------------------------------------------------------------------------------
; This is the source of a Fargo program that is intended to be executed from the TIOS
; command line. It returns the name of all folders within a list of strings.
;
;; Copyright (c) 1999 David Kuehling

;; This software is provided 'as-is', without any express or implied
;; warranty. In no event will the authors be held liable for any damages
;; arising from the use of this software.

;; Permission is granted to anyone to use this software for any purpose,
;; including commercial applications, and to alter it and redistribute it
;; freely, subject to the following restrictions:

;; 1. The origin of this software must not be misrepresented; you must not
;;    claim that you wrote the original software. If you use this software
;;    in a product, an acknowledgment in the product documentation would be
;;    appreciated but is not required.
;; 2. Altered source versions must be plainly marked as such, and must not be
;;    misrepresented as being the original software.
;; 3. This notice may not be removed or altered from any source distribution.

; Last Modification: Jan 22 1999
;
; Thanks to:
;	Gareth James for files.txt 
;	David Ellsworth for Fargo and the testfunc.asm example program
;----------------------------------------------------------------------------------------------




;----------------------------------------------------------------------------------------------
		INCLUDE	"tios.h"
;----------------------------------------------------------------------------------------------

;----------------------------------------------------------------------------------------------
		XDEF	_main
		XDEF	_tibasic
;----------------------------------------------------------------------------------------------

sizeof_SYM_ENTRY	EQU tios::SYM_ENTRY.hVal+2

;----------------------------------------------------------------------------------------------
; Push the token, specified by d0.b onto the estack.
;----------------------------------------------------------------------------------------------
PushToken:	move.w	d0,-(a7)
		jsr	tios::push_quantum
		addq.w	#2,a7
		rts

;----------------------------------------------------------------------------------------------
; MAIN
;----------------------------------------------------------------------------------------------
_main:		; get the address of the folder table and the number of folders
		move.w	FOLDER_LIST_HANDLE,d0
		tios::DEREF	d0,a2		; a2 := pointer to folder table
		addq.l	#2,a2
		move.w	(a2)+,d3		; d3 := number of folders

		; since elements of lists are stored in reversed order, we have to
		; process the folder table from its end
		move.w	d3,d4			
		mulu	#sizeof_SYM_ENTRY,d4	; d4 := size of folder table in bytes
		lea	-12(a2,d4),a2		; a2 := pointer to last folder in folder table

		; now we push all folder names as strings onto the estack
 		; everything is done in reversed order, that's why I first push the string end,
		; then the string itself and then the string begin (#0 and STR tag)
		; the same applys to the LIST, I first push the end-mark ('}') and then
		; the beginning mark and LIST tag ('{')
		subq.w	#1,d3			; d3 := counter  (#folders - 1)
		move.w	#$E5,d0			; mark end of list ('}')
		bsr	PushToken

\Loop:		lea	Folder(PC),a3		; copy folder name into zero-terminated string
		move.l	(a2)+,(a3)		; a3 := pointer to zero-terminated folder name
		move.l	(a2),4(a3)		; a2 := pointer to folder name + 4
		cmpi.b	#'9',(a3)		; if folder name begins on a number
		bls	\__NextFold		; -> skip it (these are temporary folders...)

		moveq	#0,d0			; mark end of string
		bsr	PushToken

		; copy folder-name onto estack (including the trailing zero)
\__StrLoop:	move.b	(a3)+,d0		; push one character onto estack
		bsr	PushToken
		tst.b	-1(a3)
		bne	\__StrLoop
		moveq	#$2D,d0			; push STR tag (beginning of string)
		bsr	PushToken

\__NextFold:	lea	-sizeof_SYM_ENTRY-4(a2),a2	; process next folder name
		dbra	d3,\Loop

		move.w	#$D9,d0			; push a LIST - tag (beginning of list; ('{'))
		bsr	PushToken

		move.b	#2,tios::globals+$126E	; indicate that there is a return value

		rts


;==============================================================================================
; Data
;==============================================================================================
		EVEN
Folder:		dc.b	"        ",0		; to zero-terminate a folder name


;==============================================================================================
; Function Definition
;==============================================================================================
		SECTION _tibasic
		dc.b	$E9		
		dc.b	$0F,$E4			; EndFunc
		dc.b	$00,$E8			; :
		dc.b	$17,$E4			; Func
		dc.b	$E5,			; ()
		dc.b	$00,$00,$40,$DC 
_tibasic:
		END









